<?php
/*-------------------------------------------------------
 * @Module Name: LS iFace
 * @Module URI: http://idea2.ru
 * @Description: Идеальный Интерфейс
 * @Version: 0.01
 * @Author: Vladimir (noonv)
 * @Author URI: http://
 * @LiveStreet Version: 0.3.1
 * @License: idea2.ru
 *----------------------------------------------------------------------------
 */

/**
 * Обработка страницы модулей
 *
 */
class PluginIface_ActionIface extends ActionPlugin 
{
	protected $oUserCurrent=null;
	
	public function Init() {
		$this->oUserCurrent=$this->User_GetUserCurrent();
		$this->SetDefaultEvent('friends');
		$this->Viewer_AddHtmlTitle('Идеальный Интерфейс');
	}
	/**
	 * Регистрируем евенты
	 *
	 */
	protected function RegisterEvent() {		
		$this->AddEvent('friends','EventFriends');		
		
		//$this->AddEventPreg('/^friends$/i','EventFriends');		
		
		// AJAX
		$this->AddEvent('iface_get_friends','EventAjaxSendFriends');
	}


	/**********************************************************************************
	************************ РЕАЛИЗАЦИЯ ЭКШЕНА ***************************************
	**********************************************************************************
	*/

	//
	// не найден эвент
	//
	protected function EventNotFound()
	{
		return Router::Action('iface','friends');
	}

	
	/**
	 * Отображение друзей
	 *
	 */
	protected function EventFriends() {
		/**
		 * Устанавливаем шаблон для вывода
		 */		
		$this->SetTemplateAction('friends');
	}
	
	/**
	 * Вывод друзей пользователя по ajax-запросу
	 *
	 */
	protected function EventAjaxSendFriends(){
		$this->Viewer_SetResponseAjax();
		
		$bStateError=true;
		$sMsg='';
		$sMsgTitle='';
		$sFriends=null;
		
		$sLogin = htmlspecialchars( getRequest('sLogin') );
		$sType = htmlspecialchars( getRequest('type') );

		$bWheel = htmlspecialchars( getRequest('wheel') );

		if ((func_check($sLogin,'mail') and $oUser=$this->User_GetUserByMail($sLogin))  or  $oUser=$this->User_GetUserByLogin($sLogin)){
			//
			// получаем друзей пользователя
			if( $aUserFriends = $this->User_GetUsersFriend($oUser->getId()) ){
				if ($bWheel){
					$result = $this->PluginIface_Iface_BuildFriendsRecursiveWheel($aUserFriends);
				}
				else{
					$result = $this->PluginIface_Iface_BuildFriendsRecursive($aUserFriends);
				}

				if( $result ){
					$sFriends = $result; //json_encode ($result);

					$bStateError=false;
					$sMsgTitle='Ура!';
					$sMsg='Данные получены!';
				}
				else{
					$sMsgTitle='Ошибка!';
					$sMsg='Ошибка построения! Попробуйте позже.';
				}
			}
			else
			{
				$sMsgTitle='Внимание!';
				$sMsg='Не удалось получить друзей пользователя!';
			}
		}
		else{
			$sMsgTitle='Ошибка!';
			$sMsg='Пользователь с там логином не найден!';
		}
		
		if($bStateError){
			$this->Message_AddErrorSingle($sMsg,$sMsgTitle);
		}else{
			$this->Message_AddNoticeSingle($sMsg,$sMsgTitle);
		}
		
		$this->Viewer_AssignAjax('sFriends', $sFriends);
	}
}
?>
