<?php
/*-------------------------------------------------------
 * @Module Name: LS iFace
 * @Module URI: http://idea2.ru
 * @Description: Идеальный Интерфейс
 * @Version: 0.01
 * @Author: Vladimir (noonv)
 * @Author URI: http://
 * @LiveStreet Version: 0.4
 * @License: idea2.ru
 *----------------------------------------------------------------------------
 */

set_include_path(get_include_path().PATH_SEPARATOR.dirname(__FILE__));
require_once('mapper/Iface.mapper.class.php');

/**
 * Модуль для Идеального Интерфейса
 *
 */
class PluginIface_Iface extends Module {		
	protected $oMapper;
	protected $oUserCurrent;
	/**
	 * Инициализация
	 *
	 */
	public function Init() {
		$this->oMapper=new PluginIface_Mapper_Iface($this->Database_GetConnect());
		$this->oUserCurrent=$this->User_GetUserCurrent();	
	}
	
	/**
	 * Рекурсивно обходим друзей
	 *
	 */
	public function BuildFriendsRecursive($aFriends, $bBegin=true , $iLimitLevel=IFACE_FRIENDS_DEEP) {
		static $aResult;
		static $iLevel;
		
		if ($bBegin) {
			$aResult=array();
			$iLevel=0;
		}
		//$this->Logger_Error('iLevel'.$iLevel);
		//var_dump($aFriends);
		
		foreach ($aFriends as $oUser)
		{
			// данные юзера
//			$aTemp = array('id'=>$oUser->getId(), 'login'=>$oUser->getLogin(), 'avatar'=>$oUser->getProfileAvatarPath(24), 'level'=>$iLevel, 'childNodes'=>null );
			$aTemp = array('id'=>$oUser->getId(), 'text'=>$oUser->getLogin(), 'connections'=>array());
			// 'imageUrl'=>$oUser->getProfileAvatarPath(24),

			
			$aTemp2 = array();
			// получаем 
			if( $aUserFriends = $this->User_GetUsersFriend($oUser->getId()) )
			{
				// сохраняем id-ки друзей
				foreach ($aUserFriends as $oUserF)
				{
					//$aTemp2[] = $oUserF->getId();
					$aTemp2[] = $oUserF->getId();
				}
				$aTemp['connections'] = $aTemp2;
				if( !$this->CheckMassForFriend($aResult, $aTemp['id']) )
					$aResult[] = $aTemp;
				
				// рекурсивно обходим друзей друга
				if($iLevel<$iLimitLevel)
				{
					$iLevel++;
					$this->BuildFriendsRecursive($aUserFriends, false, $iLimitLevel-$iLevel);
				}
			}
			else
			{
				if( !$this->CheckMassForFriend($aResult, $aTemp['id']) )
					$aResult[] = $aTemp;
			}
			
		}
		$iLevel--;
		return $aResult;
	}
	
	/**
	 * Рекурсивно обходим друзей - возвращаем данные в формате moowheel
	 *
	 */
	public function BuildFriendsRecursiveWheel($aFriends, $bBegin=true , $iLimitLevel=IFACE_FRIENDS_DEEP) {
		static $aResult;
		static $iLevel;
		
		if ($bBegin) {
			$aResult=array();
			$iLevel=0;
		}
		
		foreach ($aFriends as $oUser)
		{
			// данные юзера
			$aTemp = array('id'=>$oUser->getId(), 'text'=>$oUser->getLogin(),  'connections'=>array());
			//$aTemp = array('id'=>$oUser->getId(), 'text'=>$oUser->getLogin(), 'imageUrl'=>$oUser->getProfileAvatarPath(24),  'connections'=>array());
			// 'imageUrl'=>$oUser->getProfileAvatarPath(24),

			$aTemp2 = array();
			// получаем 
			if( $aUserFriends = $this->User_GetUsersFriend($oUser->getId()) )
			{
				// сохраняем id-ки друзей
				foreach ($aUserFriends as $oUserF)
				{
					$aTemp2[] = $oUserF->getId();
				}
				$aTemp['connections'] = $aTemp2;
				if( !$this->CheckMassForFriend($aResult, $aTemp['id']) )
					$aResult[] = $aTemp;
				
				// рекурсивно обходим друзей друга
				if($iLevel<$iLimitLevel)
				{
					$iLevel++;
					$this->BuildFriendsRecursiveWheel($aUserFriends, false, $iLimitLevel-$iLevel);
				}
			}
			else
			{
				if( !$this->CheckMassForFriend($aResult, $aTemp['id']) )
					$aResult[] = $aTemp;
			}
			
		}
		$iLevel--;
		return $aResult;
	}
	
	/**
	 * Проверяем есть ли уже такой юзер в массиве друзей
	 *
	 */
	public function CheckMassForFriend($aFriends, $iUserId) {
		//$this->Logger_Error('-= u '.$iUserId);
		foreach ($aFriends as $oFriend)
		{
			//$this->Logger_Error($oFriend['id']);
			//$this->Logger_Error('u '.$iUserId);
			if($oFriend['id']==$iUserId)
				return true;
		}
		return false;
	}
}
?>